﻿<%
/*
 * 概要:選択系汎用画面
 * [パラメータ説明(urlのパラメータで指定する)]
 *  ・title : 表示するタイトル
 *  ・targetTable : 検索対象とするテーブル名
 *  ・mflg : メイン選択の有無（有り:true）
 *  ・multi : 複数選択の有無（有り:true）
 *  ・preLoadList : 初回検索を行わない場合 "1"を指定する
 * [パラメータ説明(showModalDialog()の第２引数として指定する)]
 *  ・id : 既に選択されているID（,で繋げた文字列）
 *  ・name : 上記IDに対応した名称（,で繋げた文字列）
 *  ・main : 上記IDに対応したメインフラグ
 *  ・sel : 上記IDに対応した全体・一部フラグ
 *  ・gflg : 上記IDに対応したグループフラグ
 *  ・sort : 上記IDに対応した表示順
 * [イベント説明]
 * 1.画面表示時
 *    説明：初期化を行う。
 *          ①初期選択値の設定
 *    実行function：init();
 *
 * 2.検索ボタン
 *    説明：指定の条件で検索する。
 *    processId ：common
 *    action    ：selectList
 *    実行function：searchClick();
 *
 * 3.決定ボタン
 *    説明：選択済みの値を親Windowに返す
 *    実行function：kettei();
 *      戻り値は以下の通り
 *      [0] :id（カンマ区切りで返す）
 *      [1] :name（カンマ区切りで返す）
 *      [2] :メインフラグ（カンマ区切りで返す）（メイン==1、メインでない==0）
 *      [3] :全体・一部フラグ（全体==1、一部==0）
 *      [4] :グループフラグ
 *      [5] :表示順
 * 作成日:2005/11/7
 * 作成者:y-hamanaka
 */
%>
<%
response.setHeader("Expires", "-1");
response.setHeader("Pragma","no-cache");
response.setHeader("Cache-Control","no-cache");
%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<%@ page contentType="text/html; charset=utf-8" %>
<%@ include file="../sys/var.jsp" %>
<%@ page import="java.text.*" %>

<html>
<head>
  <meta http-equiv="Expires" content="Thu, 01 Dec 1994 16:00:00 GMT">
  <meta http-equiv="Cache-Control" content="no-cache">
  <meta http-equiv="Pragma" content="no-cache">

  <meta http-equiv="Content-Type" content="text/html; charset=utf-8">

  <title>Common Select</title>
  <link href="<%= STYLE_DIR %>popwin.css" type="text/css" rel="stylesheet">

  <script src="<%= JS_DIR %>htmlEntity.js"></script>

  <script language="JavaScript">
    var idList        = new Array();
    var nameList      = new Array();
    var mainList      = new Array();
    var allSelectList = new Array();
    var gflgList      = new Array();
    var sortList      = new Array();

    var selectedId   = "<%= commonMessage.getReqStr("selectedId") %>";
    var selectedName = "<%= TextUtil.cnvJsp(commonMessage.getReqStr("selectedName").replaceAll("\\\\","\\\\\\\\"), commonMessage.getCharCd()) %>";
    var selectedMain = "<%= commonMessage.getReqStr("selectedMain") %>";
    var selectedAll  = "<%= commonMessage.getReqStr("selectedAll") %>";
    var selectedGflg = "<%= commonMessage.getReqStr("selectedGflg") %>";
    var selectedSort = "<%= TextUtil.cnvJsp(commonMessage.getReqStr("selectedSort").replaceAll("\\\\","\\\\\\\\"), commonMessage.getCharCd()) %>";

    var mflg    = "<%= commonMessage.getReqStr("mflg") %>";
    var multi   = "<%= commonMessage.getReqStr("multi") %>";
    var mySelf  = "<%= commonMessage.getReqStr("myself") %>";
    var searchflg = "<%= commonMessage.getReqStr("searchflg") %>";

    var isLoadComplete = false;

    function init(){
      <% if("1".equals(commonMessage.getReqStr("preLoadList"))){ %>
        searchMessageArea.innerHTML = '${hfn:getMsg("sel.errMsg")}';
      <% } %>

      window.name = "mainWindow";
      if(mySelf == "1" && selectedId.length !=0){
        idList        = selectedId.split(",");
        itemsName     = HTMLDecode(selectedName);
        nameList      = itemsName.split(",");
        mainList      = selectedMain.split(",");
        allSelectList = selectedAll.split(",");
        gflgList      = selectedGflg.split(",");
        itemsSort     = HTMLDecode(selectedSort);
        sortList      = itemsSort.split(",");
      } else {
        if (searchflg != "1"){
          var param = window.dialogArguments;
          if (param.id != "") {
            idList         = param.id.split(",");
            nameList       = param.name.split(",");
            mainList       = param.main.split(",");
            allSelectList  = param.sel.split(",");
            gflgList       = param.gflg.split(",");
            sortList       = param.sort.split(",");
          }
          if (param.ttl != "") {
        	  dispTitle.innerHTML = param.ttl;
        	  document.mainForm.title.value = param.ttl;
          }
        }
      }

      dispList(true);
      isLoadComplete = true;
    }

    function dispList(isEncode){
      var str = "";
      var tmp = "";
      str = "<table id='lstUserTbl' width='100%' cellspacing='0' boroder='0'>";
      for(kk = 0; kk < idList.length; kk++){
        str += "<tr>";
        if (mflg == "1") {
          str += "<td><input type='radio' name='main' value='1'";
          str += " onclick='mainSel("+kk+");'";
          if (mainList[kk] == "1") str += " Checked";
          str += "></td>";
        }
        if(isEncode){
          tmp = nameList[kk];
        }else{
          tmp = nameList[kk];
        }
        str += "<td>"+ tmp +"</td>";
				str += "<td nowrap><a href=# onclick='delClick("+kk+"); return false;'>";
				str += '${hfn:getMsg("sel.del")}';
        str += "</a></td></tr>";
      }
      str += "</table>";
      document.all("lstUser").innerHTML = str;
    }

    function add(selno){
      if(isSet(selno)){
        return false;
      }

      var idx = idList.length;
      if(multi == "0"){
        idx = 0;
      }

      var txtNm = "nameVal_"+ selno;
      var valNm = document.mainForm.elements[txtNm].value;
      txtNm = "gflg_" + selno;
      var gflg = document.mainForm.elements[txtNm].value;
      txtNm = "sort_" + selno;
      var sort = document.mainForm.elements[txtNm].value;

      var selDsp = "";
      var allSel = "0";

      idList[idx]        = selno;
      nameList[idx]      = valNm+selDsp;
      allSelectList[idx] = allSel;
      mainList[idx]      = 0;
      gflgList[idx]      = gflg;
      sortList[idx]      = sort;

      dispList(true);
    }

    function isSet(selno){
     for(ii=0; ii < idList.length; ii++){
       if(idList[ii] == selno){
          return true;
       }
     }
     return false;
    }

    function mainSel(pos) {
      for(ii=0; ii < mainList.length; ii++) {
        mainList[ii] = 0;
      }
      mainList[pos] = 1;
    }

    function kettei(){
      var chk = 0;
      for(ii=0; ii < mainList.length; ii++){
        chk += mainList[ii];
      }

      if(mainList.length > 0 && chk == 0 && mflg == "1") {
        alert('${hfn:getMsg("sel.mainErr")}');
        return false;
      }

      var aryKetteiVal = new Array(6);
      aryKetteiVal[0] = idList.join(",");
      aryKetteiVal[1] = nameList.join(",");
      aryKetteiVal[2] = mainList.join(",");
      aryKetteiVal[3] = allSelectList.join(",");
      aryKetteiVal[4] = gflgList.join(",");
      aryKetteiVal[5] = sortList.join(",");

      window.returnValue = aryKetteiVal;
      self.window.close();
    }

    function cancel(){
      self.window.close();
    }

    function delClick(delpos){
      var pos;
      var bflen = idList.length;
      for(ii = delpos + 1; ii < bflen; ii++){
        idList[ii-1]        = idList[ii];
        nameList[ii-1]      = nameList[ii];
        allSelectList[ii-1] = allSelectList[ii];
        mainList[ii-1]      = mainList[ii];
        gflgList[ii-1]      = gflgList[ii];
        sortList[ii-1]      = sortList[ii];
      }
      idList.length        = bflen-1;
      nameList.length      = bflen-1;
      allSelectList.length = bflen-1;
      mainList.length      = bflen-1;
      gflgList.length      = bflen-1;
      sortList.length      = bflen-1;

      dispList(true);
    }


    function searchClick(){
      if(isLoadComplete==false){
        return;
      }
      document.mainForm.selectedId.value   = idList.join(",");
      document.mainForm.selectedName.value = nameList.join(",");
      document.mainForm.selectedMain.value = mainList.join(",");
      document.mainForm.selectedAll.value  = allSelectList.join(",");
      document.mainForm.selectedGflg.value = gflgList.join(",");
      document.mainForm.selectedSort.value = sortList.join(",");
      document.mainForm.searchflg.value = "1";
      searchMessageArea.innerHTML = '${hfn:getMsg("sel.srchMsg")}';

      document.mainForm.pluginId.value = document.mainForm.oplgid.value;
      document.mainForm.action.value = document.mainForm.oact.value;
      window.mainForm.submit();
    }

  </script>
</head>

<body onload="init();" class="popbg dialog">
<form name="mainForm" action="<%= ActionVal %>" target="mainWindow" method="POST" enctype="application/x-www-form-urlencoded">
  <htl:comfld plg="<%= MAIN_ID %>" pid="common" act="commonSelect" pageact="get" />

  <input type="hidden" name="myself"        value="1">
  <input type="hidden" name="selectedId"    value="">
  <input type="hidden" name="selectedName"  value="">
  <input type="hidden" name="selectedMain"  value="">
  <input type="hidden" name="selectedAll"   value="">
  <input type="hidden" name="selectedGflg"  value="">
  <input type="hidden" name="selectedSort"  value="">

  <htl:hidden item="oplgid"/>
  <htl:hidden item="oact"/>

  <htl:hidden item="title" />
  <htl:hidden item="subTitle" />
  <htl:hidden item="targetTable" />
  <htl:hidden item="mflg" />
  <htl:hidden item="multi" />
  <htl:hidden item="cond"/>
  <htl:hidden item="searchflg" />
  <htl:hidden item="connectParam" />

  <div id="contents">
	  <h1><span id="dispTitle"><htl:dispitem item="dsptitle"/></span></h1>
	  <span id="searchMessageArea"></span>
	  <div class="btn" style="text-align:right;">
	    <img src="<%= BUTTON_DIR %>bs_cancel.gif" alt="cansel" class="btn65-23" border="0" onclick="cancel(); return false;">
	    &nbsp;&nbsp;&nbsp;
	    <img src="<%= BUTTON_DIR %>bs_kettei.gif" alt="OK" class="btn85-25" border="0" onclick="kettei(); return false;">
	  </div>
    <p>
    <div id="aWaku" class="input">
      <div id="left600">
        <table width="100%" border="0" cellpadding="1" cellspacing="0" class="readlist">
          <tr>
            <th nowrap id="listTitle">${hfn:getMsg("sel.hed")}</th>
            <td>
              &nbsp;<htl:keyfld item="searchVal" cls="textStr" size="17" maxlength="50" attr="onfocus=\"this.style.background='#eff'\" onBlur=\"this.style.background='#fff'\"" />
            </td>
            <td nowrap>
              <img src="<%= BUTTON_DIR %>bs_kensaku.gif" class="btnbs" align="absmiddle" onclick="searchClick(); return false;">
            </td>
        </tr>
      </table>
      <% if(commonMessage.resSize() == 0 && !"1".equals(commonMessage.getReqStr("preLoadList"))){ %>
        <table width="100%" border="0" cellpadding="0" cellspacing="1" bgcolor="#ffffff">
          <tr>
             <td style="background-color:#ffffff; border:0px">
              ${hfn:getMsg("sel.noData")}
            </td>
          <tr>
        </table>
      <% } else { %>

        <table width="100%" cellspacing="0" boroder="0">
          <%
          int pos = 0;
          String cls = "ListLightblue";
          if (pos % 2 == 0) cls = "ListBlue";

          for (Map<String,String> detailData : commonMessage) {
            String selno = TextUtil.cnvJsp(detailData.get("idVal"), commonMessage.getCharCd());
            String val = TextUtil.cnvJsp(detailData.get("nameVal"), commonMessage.getCharCd());
          %>
              <tr>
                <td colspan="2" class="<%=cls%>" >
                <ul>
                   <li>
                     <a href="#" onclick="add('<%=selno%>'); return false;"><%=val%>
                       <input type="hidden" name="nameVal_<%=selno%>" value="<%=val%>">
                       <input type="hidden" name="gflg_<%=selno%>" value="">
                       <input type="hidden" name="sort_<%=selno%>" value="">
                     </a>
                  </li>
                </ul>
              </td>
            </tr>
          <%
            pos++;
          }
          %>
          <input type="hidden" name="txtpos" value="<%=pos%>">
        </table>
      <% } %>
    </div>


    <div id="subRight" style='padding:2px;'>
      <div id="lstUser">
      </div>
    </div>
  </div>

  <div style="visibility:hidden">
    <input name="dummy">
  </div>
</form>
</body>
</frame>
</html>
